Index: include/ndk/pstypes.h
===================================================================
--- include/ndk/pstypes.h	(revision 21808)
+++ include/ndk/pstypes.h	(working copy)
@@ -613,252 +864,371 @@
 } TERMINATION_PORT, *PTERMINATION_PORT;
 
 //
+// Per-Process APC Rate Limiting
+//
+typedef struct _PSP_RATE_APC
+{
+    union
+    {
+        SINGLE_LIST_ENTRY NextApc;
+        ULONGLONG ExcessCycles;
+    };
+    ULONGLONG TargetGEneration;
+    KAPC RateApc;
+} PSP_RATE_APC, *PPSP_RATE_APC;
+
+//
 // Executive Thread (ETHREAD)
 //
 #include <pshpack4.h>
 typedef struct _ETHREAD
 {
-    KTHREAD                        Tcb;                         /* 000 */
-    PVOID                          Padding;                     /* 1B4 */
-    LARGE_INTEGER                  CreateTime;                  /* 1B8 */
+    KTHREAD Tcb;
+    PVOID Padding;
+    LARGE_INTEGER CreateTime;
     union
     {
-        LARGE_INTEGER              ExitTime;                    /* 1C0 */
-        LIST_ENTRY                 LpcReplyChain;               /* 1C0 */
-        LIST_ENTRY                 KeyedWaitChain;              /* 1C0 */
+        LARGE_INTEGER ExitTime;
+        LIST_ENTRY LpcReplyChain;
+        LIST_ENTRY KeyedWaitChain;
     };
     union
     {
-        NTSTATUS                   ExitStatus;                  /* 1C8 */
-        PVOID                      OfsChain;                    /* 1C8 */
+        NTSTATUS ExitStatus;
+        PVOID OfsChain;
     };
-    LIST_ENTRY                     PostBlockList;               /* 1CC */
+    LIST_ENTRY PostBlockList;
     union
     {
-        struct _TERMINATION_PORT   *TerminationPort;            /* 1D4 */
-        struct _ETHREAD            *ReaperLink;                 /* 1D4 */
-        PVOID                      KeyedWaitValue;              /* 1D4 */
+        struct _TERMINATION_PORT *TerminationPort;
+        struct _ETHREAD *ReaperLink;
+        PVOID KeyedWaitValue;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+        PVOID Win32StartParameter;
+#endif
     };
-    KSPIN_LOCK                     ActiveTimerListLock;         /* 1D8 */
-    LIST_ENTRY                     ActiveTimerListHead;         /* 1DC */
-    CLIENT_ID                      Cid;                         /* 1E4 */
+    KSPIN_LOCK ActiveTimerListLock;
+    LIST_ENTRY ActiveTimerListHead;
+    CLIENT_ID Cid;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    KSEMAPHORE KeyedWaitSemaphore;
+#else
     union
     {
-        KSEMAPHORE                 LpcReplySemaphore;           /* 1EC */
-        KSEMAPHORE                 KeyedReplySemaphore;         /* 1EC */
+        KSEMAPHORE LpcReplySemaphore;
+        KSEMAPHORE KeyedReplySemaphore;
     };
     union
     {
-        PVOID                      LpcReplyMessage;             /* 200 */
-        PVOID                      LpcWaitingOnPort;            /* 200 */
+        PVOID LpcReplyMessage;
+        PVOID LpcWaitingOnPort;
     };
-    PPS_IMPERSONATION_INFORMATION  ImpersonationInfo;           /* 204 */
-    LIST_ENTRY                     IrpList;                     /* 208 */
-    ULONG                          TopLevelIrp;                 /* 210 */
-    PDEVICE_OBJECT                 DeviceToVerify;              /* 214 */
-    struct _EPROCESS               *ThreadsProcess;             /* 218 */
-    PKSTART_ROUTINE                StartAddress;                /* 21C */
+#endif
+    PPS_IMPERSONATION_INFORMATION ImpersonationInfo;
+    LIST_ENTRY IrpList;
+    ULONG TopLevelIrp;
+    PDEVICE_OBJECT DeviceToVerify;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    PPSP_RATE_APC RateControlApc;
+#else
+    struct _EPROCESS *ThreadsProcess;
+#endif
+    PVOID Win32StartAddress;
     union
     {
-        PVOID                      Win32StartAddress;           /* 220 */
-        ULONG                      LpcReceivedMessageId;        /* 220 */
+        PKSTART_ROUTINE StartAddress;
+        ULONG LpcReceivedMessageId;
     };
-    LIST_ENTRY                     ThreadListEntry;             /* 224 */
-    EX_RUNDOWN_REF                 RundownProtect;              /* 22C */
-    EX_PUSH_LOCK                   ThreadLock;                  /* 230 */
-    ULONG                          LpcReplyMessageId;           /* 234 */
-    ULONG                          ReadClusterSize;             /* 238 */
-    ACCESS_MASK                    GrantedAccess;               /* 23C */
+    LIST_ENTRY ThreadListEntry;
+    EX_RUNDOWN_REF RundownProtect;
+    EX_PUSH_LOCK ThreadLock;
+#if (NTDDI_VERSION < NTDDI_LONGHORN)
+    ULONG LpcReplyMessageId;
+#endif
+    ULONG ReadClusterSize;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    ULONG SpareUlong0;
+#else
+    ACCESS_MASK GrantedAccess;
+#endif
     union
     {
         struct
         {
-           ULONG                   Terminated:1;
-           ULONG                   DeadThread:1;
-           ULONG                   HideFromDebugger:1;
-           ULONG                   ActiveImpersonationInfo:1;
-           ULONG                   SystemThread:1;
-           ULONG                   HardErrorsAreDisabled:1;
-           ULONG                   BreakOnTermination:1;
-           ULONG                   SkipCreationMsg:1;
-           ULONG                   SkipTerminationMsg:1;
+           ULONG Terminated:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+           ULONG ThreadInserted:1;
+#else
+           ULONG DeadThread:1;
+#endif
+           ULONG HideFromDebugger:1;
+           ULONG ActiveImpersonationInfo:1;
+           ULONG SystemThread:1;
+           ULONG HardErrorsAreDisabled:1;
+           ULONG BreakOnTermination:1;
+           ULONG SkipCreationMsg:1;
+           ULONG SkipTerminationMsg:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+           ULONG CreateMsgSent:1;
+           ULONG ThreadIoPriority:3;
+           ULONG ThreadPagePriority:3;
+           ULONG PendingRatecontrol:1;
+#endif
         };
-        ULONG                      CrossThreadFlags;            /* 240 */
+        ULONG CrossThreadFlags;
     };
     union
     {
         struct
         {
-           ULONG                   ActiveExWorker:1;
-           ULONG                   ExWorkerCanWaitUser:1;
-           ULONG                   MemoryMaker:1;
-           ULONG                   KeyedEventInUse:1;
+           ULONG ActiveExWorker:1;
+           ULONG ExWorkerCanWaitUser:1;
+           ULONG MemoryMaker:1;
+           ULONG KeyedEventInUse:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+           ULONG RateApcState:2;
+#endif
         };
-        ULONG                      SameThreadPassiveFlags;      /* 244 */
+        ULONG SameThreadPassiveFlags;
     };
     union
     {
         struct
         {
-           ULONG                   LpcReceivedMsgIdValid:1;
-           ULONG                   LpcExitThreadCalled:1;
-           ULONG                   AddressSpaceOwner:1;
-           ULONG                   OwnsProcessWorkingSetExclusive:1;
-           ULONG                   OwnsProcessWorkingSetShared:1;
-           ULONG                   OwnsSystemWorkingSetExclusive:1;
-           ULONG                   OwnsSystemWorkingSetShared:1;
-           ULONG                   OwnsSessionWorkingSetExclusive:1;
-           ULONG                   OwnsSessionWorkingSetShared:1;
-           ULONG                   ApcNeeded:1;
+           ULONG LpcReceivedMsgIdValid:1;
+           ULONG LpcExitThreadCalled:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+           ULONG Spare:1;
+#else
+           ULONG AddressSpaceOwner:1;
+#endif
+           ULONG OwnsProcessWorkingSetExclusive:1;
+           ULONG OwnsProcessWorkingSetShared:1;
+           ULONG OwnsSystemWorkingSetExclusive:1;
+           ULONG OwnsSystemWorkingSetShared:1;
+           ULONG OwnsSessionWorkingSetExclusive:1;
+           ULONG OwnsSessionWorkingSetShared:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+           ULONG SupressSymbolLoad:1;
+           ULONG Spare1:3;
+           ULONG PriorityRegionActive:4;
+#else
+           ULONG ApcNeeded:1;
+#endif
         };
-        ULONG                      SameThreadApcFlags;          /* 248 */
+        ULONG SameThreadApcFlags;
     };
-    UCHAR                          ForwardClusterOnly;          /* 24C */
-    UCHAR                          DisablePageFaultClustering;  /* 24D */
-    UCHAR                          ActiveFaultCount;            /* 24E */
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    UCHAR CacheManagerActive;
+#else
+    UCHAR ForwardClusterOnly;
+#endif
+    UCHAR DisablePageFaultClustering;
+    UCHAR ActiveFaultCount;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    ULONG AlpcMessageId;
+    union
+    {
+        PVOID AlpcMessage;
+        ULONG AlpcReceiveAttributeSet;
+    };
+    LIST_ENTRY AlpcWaitListEntry;
+    KSEMAPHORE AlpcWaitSemaphore;
+    ULONG CacheManagerCount;
+#endif
 } ETHREAD;
 
-#if defined(_NTOSKRNL_)
-    #include <internal/mm.h>
-#endif
-
 //
 // Executive Process (EPROCESS)
 //
 typedef struct _EPROCESS
 {
-    KPROCESS              Pcb;                          /* 000 */
-    EX_PUSH_LOCK          ProcessLock;                  /* 078 */
-    LARGE_INTEGER         CreateTime;                   /* 080 */
-    LARGE_INTEGER         ExitTime;                     /* 088 */
-    EX_RUNDOWN_REF        RundownProtect;               /* 090 */
-    HANDLE                UniqueProcessId;              /* 094 */
-    LIST_ENTRY            ActiveProcessLinks;           /* 098 */
-    ULONG                 QuotaUsage[3];                /* 0A0 */
-    ULONG                 QuotaPeak[3];                 /* 0AC */
-    ULONG                 CommitCharge;                 /* 0B8 */
-    ULONG                 PeakVirtualSize;              /* 0BC */
-    ULONG                 VirtualSize;                  /* 0C0 */
-    LIST_ENTRY            SessionProcessLinks;          /* 0C4 */
-    PVOID                 DebugPort;                    /* 0CC */
-    PVOID                 ExceptionPort;                /* 0D0 */
-    PHANDLE_TABLE         ObjectTable;                  /* 0D4 */
-    EX_FAST_REF           Token;                        /* 0D8 */
-    ULONG                 WorkingSetPage;               /* 0DC */
-    KGUARDED_MUTEX        AddressCreationLock;          /* 0E0 */
-    KSPIN_LOCK            HyperSpaceLock;               /* 100 */
-    PETHREAD              ForkInProgress;               /* 104 */
-    ULONG                 HardwareTrigger;              /* 108 */
-    MM_AVL_TABLE          PhysicalVadroot;              /* 10C */
-    PVOID                 CloneRoot;                    /* 110 */
-    ULONG                 NumberOfPrivatePages;         /* 114 */
-    ULONG                 NumberOfLockedPages;          /* 118 */
-    PVOID                 *Win32Process;                /* 11C */
-    struct _EJOB          *Job;                         /* 120 */
-    PVOID                 SectionObject;                /* 124 */
-    PVOID                 SectionBaseAddress;           /* 128 */
-    PEPROCESS_QUOTA_BLOCK QuotaBlock;                   /* 12C */
-    PPAGEFAULT_HISTORY    WorkingSetWatch;              /* 130 */
-    PVOID                 Win32WindowStation;           /* 134 */
-    HANDLE                InheritedFromUniqueProcessId; /* 138 */
-    PVOID                 LdtInformation;               /* 13C */
-    PVOID                 VadFreeHint;                  /* 140 */
-    PVOID                 VdmObjects;                   /* 144 */
-    PVOID                 DeviceMap;                    /* 148 */
-    PVOID                 Spare0[3];                    /* 14C */
+    KPROCESS Pcb;
+    EX_PUSH_LOCK ProcessLock;
+    LARGE_INTEGER CreateTime;
+    LARGE_INTEGER ExitTime;
+    EX_RUNDOWN_REF RundownProtect;
+    HANDLE UniqueProcessId;
+    LIST_ENTRY ActiveProcessLinks;
+    ULONG QuotaUsage[3];
+    ULONG QuotaPeak[3];
+    ULONG CommitCharge;
+    ULONG PeakVirtualSize;
+    ULONG VirtualSize;
+    LIST_ENTRY SessionProcessLinks;
+    PVOID DebugPort;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
     union
     {
-        HARDWARE_PTE_X86  PagedirectoryPte;             /* 158 */
-        ULONGLONG         Filler;                       /* 158 */
+        PVOID ExceptionPortData;
+        ULONG ExceptionPortValue;
+        UCHAR ExceptionPortState:3;
     };
-    ULONG                 Session;                      /* 160 */
-    CHAR                  ImageFileName[16];            /* 164 */
-    LIST_ENTRY            JobLinks;                     /* 174 */
-    PVOID                 LockedPagesList;              /* 17C */
-    LIST_ENTRY            ThreadListHead;               /* 184 */
-    PVOID                 SecurityPort;                 /* 188 */
-    PVOID                 PaeTop;                       /* 18C */
-    ULONG                 ActiveThreads;                /* 190 */
-    ACCESS_MASK           GrantedAccess;                /* 194 */
-    ULONG                 DefaultHardErrorProcessing;   /* 198 */
-    NTSTATUS              LastThreadExitStatus;         /* 19C */
-    struct _PEB*          Peb;                          /* 1A0 */
-    EX_FAST_REF           PrefetchTrace;                /* 1A4 */
-    LARGE_INTEGER         ReadOperationCount;           /* 1A8 */
-    LARGE_INTEGER         WriteOperationCount;          /* 1B0 */
-    LARGE_INTEGER         OtherOperationCount;          /* 1B8 */
-    LARGE_INTEGER         ReadTransferCount;            /* 1C0 */
-    LARGE_INTEGER         WriteTransferCount;           /* 1C8 */
-    LARGE_INTEGER         OtherTransferCount;           /* 1D0 */
-    ULONG                 CommitChargeLimit;            /* 1D8 */
-    ULONG                 CommitChargePeak;             /* 1DC */
-    PVOID                 AweInfo;                      /* 1E0 */
-    SE_AUDIT_PROCESS_CREATION_INFO SeAuditProcessCreationInfo; /* 1E4 */
-    MMSUPPORT             Vm;                           /* 1E8 */
-    LIST_ENTRY            MmProcessLinks;               /* 230 */
-    ULONG                 ModifiedPageCount;            /* 238 */
-    ULONG                 JobStatus;                    /* 23C */
+#else
+    PVOID ExceptionPort;
+#endif
+    PHANDLE_TABLE ObjectTable;
+    EX_FAST_REF Token;
+    ULONG WorkingSetPage;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    EX_PUSH_LOCK AddressCreationLock;
+    PETHREAD RotateInProgress;
+#else
+    KGUARDED_MUTEX AddressCreationLock;
+    KSPIN_LOCK HyperSpaceLock;
+#endif
+    PETHREAD ForkInProgress;
+    ULONG HardwareTrigger;
+    MM_AVL_TABLE PhysicalVadroot;
+    PVOID CloneRoot;
+    ULONG NumberOfPrivatePages;
+    ULONG NumberOfLockedPages;
+    PVOID *Win32Process;
+    struct _EJOB *Job;
+    PVOID SectionObject;
+    PVOID SectionBaseAddress;
+    PEPROCESS_QUOTA_BLOCK QuotaBlock;
+    PPAGEFAULT_HISTORY WorkingSetWatch;
+    PVOID Win32WindowStation;
+    HANDLE InheritedFromUniqueProcessId;
+    PVOID LdtInformation;
+    PVOID VadFreeHint;
+    PVOID VdmObjects;
+    PVOID DeviceMap;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    ULONG AlpcPagedPoolQuotaCache;
+    PVOID EtwDataSource;
+    PVOID FreeTebHint;
+#else
+    PVOID Spare0[3];
+#endif
     union
     {
+        HARDWARE_PTE_X86 PagedirectoryPte;
+        ULONGLONG Filler;
+    };
+    ULONG Session;
+    CHAR ImageFileName[16];
+    LIST_ENTRY JobLinks;
+    PVOID LockedPagesList;
+    LIST_ENTRY ThreadListHead;
+    PVOID SecurityPort;
+    PVOID PaeTop;
+    ULONG ActiveThreads;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    ULONG ImagePathHash;
+#else
+    ACCESS_MASK GrantedAccess;
+#endif
+    ULONG DefaultHardErrorProcessing;
+    NTSTATUS LastThreadExitStatus;
+    struct _PEB* Peb;
+    EX_FAST_REF PrefetchTrace;
+    LARGE_INTEGER ReadOperationCount;
+    LARGE_INTEGER WriteOperationCount;
+    LARGE_INTEGER OtherOperationCount;
+    LARGE_INTEGER ReadTransferCount;
+    LARGE_INTEGER WriteTransferCount;
+    LARGE_INTEGER OtherTransferCount;
+    ULONG CommitChargeLimit;
+    ULONG CommitChargePeak;
+    PVOID AweInfo;
+    SE_AUDIT_PROCESS_CREATION_INFO SeAuditProcessCreationInfo;
+    MMSUPPORT Vm;
+    LIST_ENTRY MmProcessLinks;
+    ULONG ModifiedPageCount;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    union
+    {
         struct
         {
-            ULONG         CreateReported:1;
-            ULONG         NoDebugInherit:1;
-            ULONG         ProcessExiting:1;
-            ULONG         ProcessDelete:1;
-            ULONG         Wow64SplitPages:1;
-            ULONG         VmDeleted:1;
-            ULONG         OutswapEnabled:1;
-            ULONG         Outswapped:1;
-            ULONG         ForkFailed:1;
-            ULONG         Wow64VaSpace4Gb:1;
-            ULONG         AddressSpaceInitialized:2;
-            ULONG         SetTimerResolution:1;
-            ULONG         BreakOnTermination:1;
-            ULONG         SessionCreationUnderway:1;
-            ULONG         WriteWatch:1;
-            ULONG         ProcessInSession:1;
-            ULONG         OverrideAddressSpace:1;
-            ULONG         HasAddressSpace:1;
-            ULONG         LaunchPrefetched:1;
-            ULONG         InjectInpageErrors:1;
-            ULONG         VmTopDown:1;
-            ULONG         ImageNotifyDone:1;
-            ULONG         PdeUpdateNeeded:1;
-            ULONG         VdmAllowed:1;
-            ULONG         SmapAllowed:1;
-            ULONG         CreateFailed:1;
-            ULONG         DefaultIoPriority:3;
-            ULONG         Spare1:1;
-            ULONG         Spare2:1;
+            ULONG JobNotReallyActive:1;
+            ULONG AccountingFolded:1;
+            ULONG NewProcessReported:1;
+            ULONG ExitProcessReported:1;
+            ULONG ReportCommitChanges:1;
+            ULONG LastReportMemory:1;
+            ULONG ReportPhysicalPageChanges:1;
+            ULONG HandleTableRundown:1;
+            ULONG NeedsHandleRundown:1;
+            ULONG RefTraceEnabled:1;
+            ULONG NumaAware:1;
+            ULONG ProtectedProcess:1;
+            ULONG DefaultPagePriority:3;
+            ULONG ProcessDeleteSelf:1;
+            ULONG ProcessVerifierTarget:1;
         };
-        ULONG             Flags;                        /* 240 */
+        ULONG Flags2;
     };
-
-    NTSTATUS              ExitStatus;                   /* 244 */
-    USHORT                NextPageColor;                /* 248 */
+#else
+    ULONG JobStatus;
+#endif
     union
     {
         struct
         {
-            UCHAR         SubSystemMinorVersion;        /* 24A */
-            UCHAR         SubSystemMajorVersion;        /* 24B */
+            ULONG CreateReported:1;
+            ULONG NoDebugInherit:1;
+            ULONG ProcessExiting:1;
+            ULONG ProcessDelete:1;
+            ULONG Wow64SplitPages:1;
+            ULONG VmDeleted:1;
+            ULONG OutswapEnabled:1;
+            ULONG Outswapped:1;
+            ULONG ForkFailed:1;
+            ULONG Wow64VaSpace4Gb:1;
+            ULONG AddressSpaceInitialized:2;
+            ULONG SetTimerResolution:1;
+            ULONG BreakOnTermination:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+            ULONG DeprioritizeViews:1;
+#else
+            ULONG SessionCreationUnderway:1;
+#endif
+            ULONG WriteWatch:1;
+            ULONG ProcessInSession:1;
+            ULONG OverrideAddressSpace:1;
+            ULONG HasAddressSpace:1;
+            ULONG LaunchPrefetched:1;
+            ULONG InjectInpageErrors:1;
+            ULONG VmTopDown:1;
+            ULONG ImageNotifyDone:1;
+            ULONG PdeUpdateNeeded:1;
+            ULONG VdmAllowed:1;
+            ULONG SmapAllowed:1;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+            ULONG ProcessInserted:1;
+#else
+            ULONG CreateFailed:1;
+#endif
+            ULONG DefaultIoPriority:3;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+            ULONG SparePsFlags1:2;
+#else
+            ULONG Spare1:1;
+            ULONG Spare2:1;
+#endif
         };
-        USHORT            SubSystemVersion;             /* 24A */
+        ULONG Flags;
     };
-    UCHAR                 PriorityClass;                /* 24C */
-    MM_AVL_TABLE          VadRoot;                      /* 250 */
-    ULONG                 Cookie;                       /* 270 */
-
-#ifdef _REACTOS_
-    /* FIXME: WILL BE DEPRECATED WITH PUSHLOCK SUPPORT IN 0.3.0*/
-    KEVENT                LockEvent;                    /* 274 */
-    ULONG                 LockCount;                    /* 284 */
-    struct _KTHREAD       *LockOwner;                   /* 288 */
-
-    /* FIXME: MOVE TO AVL TREES                                */
-    MADDRESS_SPACE        AddressSpace;                 /* 28C */
+    NTSTATUS ExitStatus;
+#if (NTDDI_VERSION >= NTDDI_LONGHORN)
+    USHORT Spare7;
+#else
+    USHORT NextPageColor;
 #endif
+    union
+    {
+        struct
+        {
+            UCHAR SubSystemMinorVersion;
+            UCHAR SubSystemMajorVersion;
+        };
+        USHORT SubSystemVersion;
+    };
+    UCHAR PriorityClass;
+    MM_AVL_TABLE VadRoot;
+    ULONG Cookie;
 } EPROCESS;
 #include <poppack.h>
 
@@ -925,7 +1295,14 @@
     ULONG PeakProcessMemoryUsed;
     ULONG PeakJobMemoryUsed;
     ULONG CurrentJobMemoryUsed;
+#if (NTDDI_VERSION == NTDDI_WINXP)
+    FAST_MUTEX MemoryLimitsLock;
+#elif (NTDDI_VERSION == NTDDI_WS03)
     KGUARDED_MUTEX MemoryLimitsLock;
+#elif (NTDDI_VERSION >= NTDDI_LONGHORN)
+    EX_PUSH_LOCK MemoryLimitsLock;
+#endif
+    LIST_ENTRY JobSetLinks;
     ULONG MemberLevel;
     ULONG JobFlags;
 } EJOB, *PEJOB;
@@ -934,30 +1311,94 @@
 //
 // Win32K Callback Registration Data
 //
-typedef struct _W32_CALLOUT_DATA
+typedef struct _WIN32_POWEREVENT_PARAMETERS
 {
-    PW32_PROCESS_CALLBACK W32ProcessCallout;
-    PW32_THREAD_CALLBACK W32ThreadCallout;
-    PVOID UserGlobalAtomTableCallout;
-    PVOID UserPowerEventCallout;
-    PVOID UserPowerStateCallout;
-    PVOID UserJobCallout;
-    PVOID NtGdiUserFlushUserBatch;
-    OB_OPEN_METHOD DesktopOpen;
-    PVOID DesktopUnmap;
-    OB_DELETE_METHOD DesktopDelete;
-    OB_OKAYTOCLOSE_METHOD WinstaOkayToClose;
-    OB_DELETE_METHOD WinStaDelete;
-    OB_PARSE_METHOD WinStaParse;
-    OB_OPEN_METHOD WinStaOpen;
-#ifdef _REACTOS_
-    /* FIXME: REACTOS ONLY */
-    OB_FIND_METHOD WinStaFind;
-    OB_OPEN_METHOD WinStaCreate;
-    OB_CREATE_METHOD DesktopCreate;
-#endif
-} W32_CALLOUT_DATA, *PW32_CALLOUT_DATA;
+    PSPOWEREVENTTYPE EventNumber;
+    ULONG Code;
+} WIN32_POWEREVENT_PARAMETERS, *PWIN32_POWEREVENT_PARAMETERS;
 
+typedef struct _WIN32_POWERSTATE_PARAMETERS
+{
+    UCHAR Promotion;
+    POWER_ACTION SystemAction;
+    SYSTEM_POWER_STATE MinSystemState;
+    ULONG Flags;
+    POWERSTATETASK PowerStateTask;
+} WIN32_POWERSTATE_PARAMETERS, *PWIN32_POWERSTATE_PARAMETERS;
+
+typedef struct _WIN32_JOBCALLOUT_PARAMETERS
+{
+    PVOID Job;
+    PSW32JOBCALLOUTTYPE CalloutType;
+    PVOID Data;
+} WIN32_JOBCALLOUT_PARAMETERS, *PWIN32_JOBCALLOUT_PARAMETERS;
+
+typedef struct _WIN32_OPENMETHOD_PARAMETERS
+{
+    OB_OPEN_REASON OpenReason;
+    PEPROCESS Process;
+    PVOID Object;
+    ULONG GrantedAccess;
+    ULONG HandleCount;
+} WIN32_OPENMETHOD_PARAMETERS, *PWIN32_OPENMETHOD_PARAMETERS;
+
+typedef struct _WIN32_OKAYTOCLOSEMETHOD_PARAMETERS
+{
+    PEPROCESS Process;
+    PVOID Object;
+    HANDLE Handle;
+    KPROCESSOR_MODE PreviousMode;
+} WIN32_OKAYTOCLOSEMETHOD_PARAMETERS, *PWIN32_OKAYTOCLOSEMETHOD_PARAMETERS;
+
+typedef struct _WIN32_CLOSEMETHOD_PARAMETERS
+{
+    PEPROCESS Process;
+    PVOID Object;
+    ACCESS_MASK AccessMask;
+    ULONG ProcessHandleCount;
+    ULONG SystemHandleCount;
+} WIN32_CLOSEMETHOD_PARAMETERS, *PWIN32_CLOSEMETHOD_PARAMETERS;
+
+typedef struct _WIN32_DELETEMETHOD_PARAMETERS
+{
+    PVOID Object;
+} WIN32_DELETEMETHOD_PARAMETERS, *PWIN32_DELETEMETHOD_PARAMETERS;
+
+typedef struct _WIN32_PARSEMETHOD_PARAMETERS
+{
+    PVOID ParseObject;
+    PVOID ObjectType;
+    PACCESS_STATE AccessState;
+    KPROCESSOR_MODE AccessMode;
+    ULONG Attributes;
+    OUT PUNICODE_STRING CompleteName;
+    PUNICODE_STRING RemainingName;
+    PVOID Context;
+    PSECURITY_QUALITY_OF_SERVICE SecurityQos;
+    PVOID *Object;
+} WIN32_PARSEMETHOD_PARAMETERS, *PWIN32_PARSEMETHOD_PARAMETERS;
+
+typedef struct _WIN32_CALLOUTS_FPNS
+{
+    PKWIN32_PROCESS_CALLOUT ProcessCallout;
+    PKWIN32_THREAD_CALLOUT ThreadCallout;
+    PKWIN32_GLOBALATOMTABLE_CALLOUT GlobalAtomTableCallout;
+    PKWIN32_POWEREVENT_CALLOUT PowerEventCallout;
+    PKWIN32_POWERSTATE_CALLOUT PowerStateCallout;
+    PKWIN32_JOB_CALLOUT JobCallout;
+    PGDI_BATCHFLUSH_ROUTINE BatchFlushRoutine;
+    PKWIN32_OPENMETHOD_CALLOUT DesktopOpenProcedure;
+    PKWIN32_OKTOCLOSEMETHOD_CALLOUT DesktopOkToCloseProcedure;
+    PKWIN32_CLOSEMETHOD_CALLOUT DesktopCloseProcedure;
+    PKWIN32_DELETEMETHOD_CALLOUT DesktopDeleteProcedure;
+    PKWIN32_OKTOCLOSEMETHOD_CALLOUT WindowStationOkToCloseProcedure;
+    PKWIN32_CLOSEMETHOD_CALLOUT WindowStationCloseProcedure;
+    PKWIN32_DELETEMETHOD_CALLOUT WindowStationDeleteProcedure;
+    PKWIN32_PARSEMETHOD_CALLOUT WindowStationParseProcedure;
+    PKWIN32_OPENMETHOD_CALLOUT WindowStationOpenProcedure;
+    PKWIN32_WIN32DATACOLLECTION_CALLOUT Win32DataCollectionProcedure;
+} WIN32_CALLOUTS_FPNS, *PWIN32_CALLOUTS_FPNS;
+
 #endif // !NTOS_MODE_USER
 
 #endif // _PSTYPES_H
Index: include/ndk/exfuncs.h
===================================================================
--- include/ndk/exfuncs.h	(revision 21808)
+++ include/ndk/exfuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -208,6 +208,15 @@
 NTSYSCALLAPI
 NTSTATUS
 NTAPI
+NtOpenKeyedEvent(
+    OUT PHANDLE EventHandle,
+    IN ACCESS_MASK DesiredAccess,
+    IN POBJECT_ATTRIBUTES ObjectAttributes
+);
+
+NTSYSCALLAPI
+NTSTATUS
+NTAPI
 NtOpenEventPair(
     OUT PHANDLE EventPairHandle,
     IN ACCESS_MASK DesiredAccess,
@@ -369,6 +378,16 @@
 NTSYSCALLAPI
 NTSTATUS
 NTAPI
+NtReleaseKeyedEvent(
+    IN HANDLE EventHandle,
+    IN PVOID Key,
+    IN BOOLEAN Alertable,
+    IN PLARGE_INTEGER Timeout OPTIONAL
+);
+
+NTSYSCALLAPI
+NTSTATUS
+NTAPI
 NtReleaseSemaphore(
     IN HANDLE SemaphoreHandle,
     IN LONG ReleaseCount,
@@ -416,6 +435,13 @@
 NTSYSCALLAPI
 NTSTATUS
 NTAPI
+NtSetEventBoostPriority(
+    IN HANDLE EventHandle
+);
+
+NTSYSCALLAPI
+NTSTATUS
+NTAPI
 NtSetHighEventPair(
     IN HANDLE EventPairHandle
 );
@@ -488,6 +514,16 @@
 NTSYSCALLAPI
 NTSTATUS
 NTAPI
+NtWaitForKeyedEvent(
+    IN HANDLE EventHandle,
+    IN PVOID Key,
+    IN BOOLEAN Alertable,
+    IN PLARGE_INTEGER Timeout OPTIONAL
+);
+
+NTSYSCALLAPI
+NTSTATUS
+NTAPI
 NtWaitHighEventPair(
     IN HANDLE EventPairHandle
 );
@@ -536,7 +572,6 @@
 );
 
 NTSYSAPI
-NTSYSAPI
 NTSTATUS
 NTAPI
 ZwCreateEvent(
@@ -824,6 +859,7 @@
 );
 
 NTSYSAPI
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwSetEvent(
Index: include/ndk/lpcfuncs.h
===================================================================
--- include/ndk/lpcfuncs.h	(revision 21808)
+++ include/ndk/lpcfuncs.h	(working copy)
@@ -1,4 +1,4 @@
-/*++ NDK Version: 0095
+/*++ NDK Version: 0098
 
 Copyright (c) Alex Ionescu.  All rights reserved.
 
@@ -12,7 +12,7 @@
 
 Author:
 
-    Alex Ionescu (alex.ionescu@reactos.com)   06-Oct-2004
+    Alex Ionescu (alexi@tinykrnl.org) - Updated - 27-Feb-2006
 
 --*/
 
@@ -27,6 +27,7 @@
 //
 // Native calls
 //
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtAcceptConnectPort(
@@ -38,6 +39,7 @@
     PREMOTE_PORT_VIEW ClientView OPTIONAL
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtCompleteConnectPort(
@@ -58,6 +60,7 @@
     PULONG ConnectionInformationLength OPTIONAL
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtCreatePort(
@@ -68,6 +71,7 @@
     ULONG MaxPoolUsage
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtCreateWaitablePort(
@@ -78,6 +82,7 @@
     ULONG NPMessageQueueSize OPTIONAL
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtImpersonateClientOfPort(
@@ -85,6 +90,7 @@
     PPORT_MESSAGE ClientMessage
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtListenPort(
@@ -92,6 +98,7 @@
     PPORT_MESSAGE ConnectionRequest
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtQueryInformationPort(
@@ -102,6 +109,7 @@
     PULONG ReturnLength
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtReadRequestData(
@@ -113,6 +121,7 @@
     PULONG ReturnLength
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtReplyPort(
@@ -120,6 +129,7 @@
     IN PPORT_MESSAGE LpcReply
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtReplyWaitReceivePort(
@@ -129,6 +139,7 @@
     OUT PPORT_MESSAGE ReceiveMessage
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtReplyWaitReceivePortEx(
@@ -139,6 +150,7 @@
     IN PLARGE_INTEGER Timeout OPTIONAL
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtReplyWaitReplyPort(
@@ -146,6 +158,7 @@
     OUT PPORT_MESSAGE ReplyMessage
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtRequestPort(
@@ -177,6 +190,7 @@
     PULONG ConnectionInformationLength OPTIONAL
 );
 
+NTSYSCALLAPI
 NTSTATUS
 NTAPI
 NtWriteRequestData(
@@ -188,6 +202,7 @@
     PULONG ReturnLength
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwAcceptConnectPort(
@@ -199,13 +214,14 @@
     PREMOTE_PORT_VIEW ClientView OPTIONAL
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwCompleteConnectPort(
     HANDLE PortHandle
 );
 
-NTSYSCALLAPI
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwConnectPort(
@@ -219,6 +235,7 @@
     PULONG ConnectionInformationLength OPTIONAL
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwCreatePort(
@@ -229,6 +246,7 @@
     ULONG MaxPoolUsage
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwCreateWaitablePort(
@@ -239,6 +257,7 @@
     ULONG NPMessageQueueSize OPTIONAL
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwImpersonateClientOfPort(
@@ -246,6 +265,7 @@
     PPORT_MESSAGE ClientMessage
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwListenPort(
@@ -253,6 +273,7 @@
     PPORT_MESSAGE ConnectionRequest
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwQueryInformationPort(
@@ -263,6 +284,7 @@
     PULONG ReturnLength
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwReadRequestData(
@@ -274,6 +296,7 @@
     PULONG ReturnLength
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwReplyPort(
@@ -281,6 +304,7 @@
     IN PPORT_MESSAGE LpcReply
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwReplyWaitReceivePort(
@@ -290,6 +314,7 @@
     OUT PPORT_MESSAGE ReceiveMessage
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwReplyWaitReceivePortEx(
@@ -300,6 +325,7 @@
     IN PLARGE_INTEGER Timeout OPTIONAL
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwReplyWaitReplyPort(
@@ -307,6 +333,7 @@
     OUT PPORT_MESSAGE ReplyMessage
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwRequestPort(
@@ -314,7 +341,7 @@
     IN PPORT_MESSAGE LpcMessage
 );
 
-NTSYSCALLAPI
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwRequestWaitReplyPort(
@@ -323,7 +350,7 @@
     IN PPORT_MESSAGE LpcRequest
 );
 
-NTSYSCALLAPI
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwSecureConnectPort(
@@ -338,6 +365,7 @@
     PULONG ConnectionInformationLength OPTIONAL
 );
 
+NTSYSAPI
 NTSTATUS
 NTAPI
 ZwWriteRequestData(
